#ifndef _KERNEL_INTERFACE_H
#define _KERNEL_INTERFACE_H

/*
 * Copyright (C) 1993-1995 Bas Laarhoven.
 * 
 * Changes by Claus Heine.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *
 $Source: /homes/cvs/zftape/kernel-interface.h,v $
 $Author: claus $
 *
 $Revision: 1.7 $
 $Date: 1996/01/29 23:07:27 $
 $State: Exp $
 *
 * ----Description----
 *
 */

#include <linux/linkage.h>
#include <linux/signal.h>

#define _S(nr) (1<<((nr)-1))
#define _NEVER_BLOCK    (_S(SIGKILL)|_S(SIGSTOP))
#define _DONT_BLOCK     (_NEVER_BLOCK|_S(SIGINT))
#define _DO_BLOCK       (_S(SIGPIPE))
#define _BLOCK_ALL      (0xffffffffL)


#ifndef QIC117_TAPE_MAJOR
#define QIC117_TAPE_MAJOR 27
#endif

/*
 *   bits of the minor device number that define drive selection
 *   methods. Could be used one day to access multiple tape
 *   drives on the same controller.
 */
#define ZFTAPE_SELECT_0     (1 << 0)
#define ZFTAPE_SELECT_1     (1 << 1)
#define ZFTAPE_SELECT_A     0
#define ZFTAPE_SELECT_B     (ZFTAPE_SELECT_0)
#define ZFTAPE_SELECT_C     (ZFTAPE_SELECT_1)
#define ZFTAPE_SELECT_D     (ZFTAPE_SELECT_0 | ZFTAPE_SELECT_1)
#define ZFTAPE_MINOR_SEL_MASK  (ZFTAPE_SELECT_0 | ZFTAPE_SELECT_1)
/*
 *   Bits of the minor device number that control the operation mode
 */
#define FTAPE_NO_REWIND    (1 << 2)       /* mask for minor nr */
#define ZFTAPE_Q80_MODE     (1 << 3)
#define ZFTAPE_ZIP_MODE     (1 << 4)
#define ZFTAPE_RAW_MODE     (1 << 5)
#define ZFTAPE_MINOR_OP_MASK     (ZFTAPE_Q80_MODE | ZFTAPE_ZIP_MODE | ZFTAPE_RAW_MODE)
#define ZFTAPE_MINOR_MASK (ZFTAPE_MINOR_SEL_MASK | ZFTAPE_MINOR_OP_MASK | FTAPE_NO_REWIND)

#define FTAPE_UNIT      (ftape_unit & ZFTAPE_MINOR_SEL_MASK)

extern int busy_flag;

/*      kernel-interface.c defined global functions.
 */
asmlinkage extern int init_module( void);
asmlinkage extern void cleanup_module( void);

/*      kernel global functions not (yet) standard accessible
 *      (linked at load time by modules package).
 */
asmlinkage extern sys_sgetmask( void);
asmlinkage extern sys_ssetmask( int);

#endif









